#!/usr/bin/env python2
# -*- coding: utf-8 -*-
# Jussi Määttä 2014

from math import log
import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import networkx as nx

num_words = 9

words = [ "Andrey",      "Kolmogorov",  "complexity",
          "stochastic",  "porridge",    "Rissanen",
          "breakfast",   "omelette",    "broccoli" ]

count_single = [ 55500000,    2730000,  109000000,
                 9920000,     2900000,  561000,
                 1060000000,  6770000,  52800000 ]

count_pair_matrix = [ \
0, 63300, 21700000, 6390000,  347000,  735000, 408000,   1070000,  4710000,
0, 0,     861000,   479000,   14600,   378000, 213000,   6070,     60900,
0, 0,     0,        17500000, 2080000, 181000, 37100000, 2310000,  288000,
0, 0,     0,        0,        265000,  44800,  2820000,  113000,   1180000,
0, 0,     0,        0,        0,       11100,  11000000, 424000,   476000,
0, 0,     0,        0,        0,       0,      201000,   3640,     263000,
0, 0,     0,        0,        0,       0,      0,        14400000, 28700000,
0, 0,     0,        0,        0,       0,      0,        0,        609000,
0, 0,     0,        0,        0,       0,      0,        0,        0 ]

ngd_matrix = [ [ 0 for i in range(num_words) ] for j in range(num_words) ]

for i in range(num_words):
    for j in range(i + 1, num_words):
        logf1 = log(count_single[i])
        logf2 = log(count_single[j])
        logfboth = log(count_pair_matrix[i * num_words + j])
        ngd = (max(logf1, logf2) - logfboth) \
              / (log(5e10) - min(logf1, logf2))
        ngd_matrix[i][j] = ngd
        ngd_matrix[j][i] = ngd

print "The words are in the following order:\n"
for i in range(len(words)):
    print i, words[i]
print

print "Distance matrix:\n"
fd = open("q4_distance_matrix.csv", "w")
for i in range(num_words):
    for j in range(num_words):
        s = "%.4f" % ngd_matrix[i][j]
        print s,
        fd.write(s)
        if j == (num_words - 1):
            print
            fd.write('\n')
        else:
            print '\t',
            fd.write(',')
print
fd.close()

print "Minimum spanning tree..."
plt.figure()
G = nx.Graph()
G.add_nodes_from(words)
for i in range(num_words):
    for j in range(i + 1, num_words):
        G.add_edge(words[i], words[j], weight=ngd_matrix[i][j])
T = nx.minimum_spanning_tree(G)
nx.draw_graphviz(T, with_labels=True)
plt.savefig('q4_mst.pdf', transparent=True)
